LogTo("cocycles/cocycle-copointed.log");

LoadPackage("GBNP");

GBNP.ConfigPrint("x0","x1","x2");

c0:=Indeterminate(Rationals,"c0");;
c1:=Indeterminate(Rationals,"c1");;
c2:=Indeterminate(Rationals,"c2");;
d:=Indeterminate(Rationals,"d");

F:=Field(c0,c1,c2,d);
F1:=One(F);;


u:=[ [ [  ] ], [ F1 ] ];;
z:=[[[]],[0]];;

a:=[[[1]],[F1]];;
b:=[[[2]],[F1]];;
c:=[[[3]],[F1]];;

a2:=MulNP(a,a);;    
b2:=MulNP(b,b);;
cc2:=MulNP(c,c);; 

ab:=AddNP(AddNP(MulNP(a,b),MulNP(b,c),F1,F1),MulNP(c,a),F1,F1);;
ba:=AddNP(AddNP(MulNP(b,a),MulNP(c,b),F1,F1),MulNP(a,c),F1,F1);;


K1:=[a2,b2,cc2,ab,ba];;
G1:=SGrobner(K1);;

Print("The relations in the Nichols algebra are:\n");
PrintNPList(K1);

B:=BaseQA(G1,3,0);;

Print("A basis is as follows:\n");
PrintNPList(B);

#deformation

a2d:=AddNP(a2,u,F1,-c0);;
b2d:=AddNP(b2,u,F1,-c1);;
cc2d:=AddNP(cc2,u,F1,-c2);;

K1d:=[a2d,b2d,cc2d,ab,ba];;
G1d:=SGrobner(K1d);;

Print("The relations in the cleft object are:\n");
PrintNPList(K1d);



#We define the section gamma for each element B[1] to B[12] in the basis:
gammab:=function(n)
local k;
for k in [1..8] do
	if n=k then return
		B[k];
	fi;
od;
if n=9 then return
	AddNP(B[9],B[4],F1,c0);
fi;
for k in [10..12] do
	if n=k then return
		B[k];
	fi;
od;
end;;

#We let gamma be a fuction of "monomials" (that is lists u=[...])
gammam:=function(u)
local n;
for n in [1..12] do
if u=B[n][1][1] then
return
gammab(n);
fi;
od;
end;;

#Finally, we write gamma as a linear function.
gamma:=function(v)
local g, n, u;
u:=StrongNormalFormNP(v,G1);
g:=[[[]],[0]];
for n in [1..Number(u[2])] do
g:=AddNP(g,gammam(u[1][n]),1,u[2][n]);
od;
return 
StrongNormalFormNP(g,G1d);
end;;

#Next we repeat these steps for gamma inverse.

# basis
igammab:=function(n)
local k;
if n=1 then return
	B[1];
fi;
for k in [2..4] do
	if n=k then return
		AddNP(z,B[k],F1,-F1);
	fi;
od;
if n=5 then return
	AddNP(z,B[8],F1,-F1);
else if n=6 then return
	AddNP(B[6],B[7],F1,F1);
else if n=7 then return
	AddNP(z,B[6],F1,-F1);
else if n=8 then return
	AddNP(B[5],B[8],F1,F1);
else if n=9 then return
	AddNP(B[9],B[4],-F1,-c0);
fi;fi;fi;fi;fi;
for k in [10..11] do
	if n=k then return
		AddNP(z,B[k],F1,-F1);
	fi;
od;
if n=12 then return
	AddNP(B[12],B[1],F1,c2*c0-c2*c1+c0*c1);
fi;
end;

# monomials
igammam:=function(u)
local n;
for n in [1..12] do
if u=B[n][1][1] then
return
igammab(n);
fi;
od;
end;

# linear
igamma:=function(v)
local g, n, u;
u:=StrongNormalFormNP(v,G1);
g:=[[[]],[0]];
for n in [1..Number(u[2])] do
g:=AddNP(g,igammam(u[1][n]),1,u[2][n]);
od;
return 
StrongNormalFormNP(g,G1d);
end;


# Next we compute the "double coproducts" a\otimes b\to a_1\ot b_1\ot a_2b_2


GBNP.ConfigPrint("x0","x1","x2","y0","y1","y2","z0","z1","z2");

x0:=[[[1]],[1]];;
x1:=[[[2]],[1]];;
x2:=[[[3]],[1]];;

y0:=[[[4]],[1]];;
y1:=[[[5]],[1]];;
y2:=[[[6]],[1]];;

z0:=[[[7]],[1]];;
z1:=[[[8]],[1]];;
z2:=[[[9]],[1]];;

#relations

rx0:=MulNP(x0,x0);;
rx1:=MulNP(x1,x1);;
rx2:=MulNP(x2,x2);;
ry0:=MulNP(y0,y0);;
ry1:=MulNP(y1,y1);;
ry2:=MulNP(y2,y2);;
rz0:=MulNP(z0,z0);;
rz1:=MulNP(z1,z1);;
rz2:=MulNP(z2,z2);;

sx01:=AddNP(MulNP(x0,x1),AddNP(MulNP(x1,x2),MulNP(x2,x0),1,1),1,1);;
sx10:=AddNP(MulNP(x1,x0),AddNP(MulNP(x2,x1),MulNP(x0,x2),1,1),1,1);;
sy01:=AddNP(MulNP(y0,y1),AddNP(MulNP(y1,y2),MulNP(y2,y0),1,1),1,1);;
sy10:=AddNP(MulNP(y1,y0),AddNP(MulNP(y2,y1),MulNP(y0,y2),1,1),1,1);;
sz01:=AddNP(MulNP(z0,z1),AddNP(MulNP(z1,z2),MulNP(z2,z0),1,1),1,1);;
sz10:=AddNP(MulNP(z1,z0),AddNP(MulNP(z2,z1),MulNP(z0,z2),1,1),1,1);;

xy00:=AddNP(MulNP(y0,x0),MulNP(x0,y0),1,1);;
xy01:=AddNP(MulNP(y1,x0),MulNP(x0,y2),1,1);;
xy02:=AddNP(MulNP(y2,x0),MulNP(x0,y1),1,1);;
xy10:=AddNP(MulNP(y0,x1),MulNP(x1,y2),1,1);;
xy11:=AddNP(MulNP(y1,x1),MulNP(x1,y1),1,1);;
xy12:=AddNP(MulNP(y2,x1),MulNP(x1,y0),1,1);;
xy20:=AddNP(MulNP(y0,x2),MulNP(x2,y1),1,1);;
xy21:=AddNP(MulNP(y1,x2),MulNP(x2,y0),1,1);;
xy22:=AddNP(MulNP(y2,x2),MulNP(x2,y2),1,1);;

xz00:=AddNP(MulNP(z0,x0),MulNP(x0,z0),1,1);;
xz01:=AddNP(MulNP(z1,x0),MulNP(x0,z2),1,1);;
xz02:=AddNP(MulNP(z2,x0),MulNP(x0,z1),1,1);;
xz10:=AddNP(MulNP(z0,x1),MulNP(x1,z2),1,1);;
xz11:=AddNP(MulNP(z1,x1),MulNP(x1,z1),1,1);;
xz12:=AddNP(MulNP(z2,x1),MulNP(x1,z0),1,1);;
xz20:=AddNP(MulNP(z0,x2),MulNP(x2,z1),1,1);;
xz21:=AddNP(MulNP(z1,x2),MulNP(x2,z0),1,1);;
xz22:=AddNP(MulNP(z2,x2),MulNP(x2,z2),1,1);;

yz00:=AddNP(MulNP(z0,y0),MulNP(y0,z0),1,1);;
yz01:=AddNP(MulNP(z1,y0),MulNP(y0,z2),1,1);;
yz02:=AddNP(MulNP(z2,y0),MulNP(y0,z1),1,1);;
yz10:=AddNP(MulNP(z0,y1),MulNP(y1,z2),1,1);;
yz11:=AddNP(MulNP(z1,y1),MulNP(y1,z1),1,1);;
yz12:=AddNP(MulNP(z2,y1),MulNP(y1,z0),1,1);;
yz20:=AddNP(MulNP(z0,y2),MulNP(y2,z1),1,1);;
yz21:=AddNP(MulNP(z1,y2),MulNP(y2,z0),1,1);;
yz22:=AddNP(MulNP(z2,y2),MulNP(y2,z2),1,1);;


#these are the relations defining the triple (braided) coproduct of the Nichols algebra
rels3:=[
rx0,rx1,rx2,ry0,ry1,ry2,rz0,rz1,rz2,
sx01,sx10,sy01,sy10,sz01,sz10,
xy00,xy01,xy02,xy10,xy11,xy12,xy20,xy21,xy22,
xz00,xz01,xz02,xz10,xz11,xz12,xz20,xz21,xz22,
yz00,yz01,yz02,yz10,yz11,yz12,yz20,yz21,yz22
];;

G3:=SGrobner(rels3);;

#we compute the coproducts: we use d for a\mapsto a_1\ot 1\ot a_2 and e for b\mapsto 1\ot b_1\ot b_2

d0:=StrongNormalFormNP(AddNP(x0,z0,1,1),G3);;
d1:=StrongNormalFormNP(AddNP(x1,z1,1,1),G3);;
d2:=StrongNormalFormNP(AddNP(x2,z2,1,1),G3);;

e0:=StrongNormalFormNP(AddNP(y0,z0,1,1),G3);;
e1:=StrongNormalFormNP(AddNP(y1,z1,1,1),G3);;
e2:=StrongNormalFormNP(AddNP(y2,z2,1,1),G3);;

d01:=StrongNormalFormNP(MulNP(d0,d1),G3);;
d02:=StrongNormalFormNP(MulNP(d0,d2),G3);;
d10:=StrongNormalFormNP(MulNP(d1,d0),G3);;
d12:=StrongNormalFormNP(MulNP(d1,d2),G3);;

e01:=StrongNormalFormNP(MulNP(e0,e1),G3);;
e02:=StrongNormalFormNP(MulNP(e0,e2),G3);;
e10:=StrongNormalFormNP(MulNP(e1,e0),G3);;
e12:=StrongNormalFormNP(MulNP(e1,e2),G3);;

d010:=StrongNormalFormNP(MulNP(d01,d0),G3);;
d012:=StrongNormalFormNP(MulNP(d01,d2),G3);;
d102:=StrongNormalFormNP(MulNP(d10,d2),G3);;

e010:=StrongNormalFormNP(MulNP(e01,e0),G3);;
e012:=StrongNormalFormNP(MulNP(e01,e2),G3);;
e102:=StrongNormalFormNP(MulNP(e10,e2),G3);;

d0102:=StrongNormalFormNP(MulNP(d010,d2),G3);;

e0102:=StrongNormalFormNP(MulNP(e010,e2),G3);;

v:=[d0,d1,d2,d01,d02,d10,d12,d010,d012,d102,d0102];;
w:=[e0,e1,e2,e01,e02,e10,e12,e010,e012,e102,e0102];;


# The double coproducts are the products of d and e:
dcopro:=function(i,j)
return
StrongNormalFormNP(MulNP(v[i],w[j]),G3);
end;


# To apply gamma or gamma inverse on each factor, we extract the sublists involving 
# variables 1 to 3 (x's), 4 to 6 (y's) and 7 to 9 (z's) respectively.

ux:=function(u)
local g,j;
g:=[];
for j in [1..Number(u)] do
if u[j]<4 then
Add(g,u[j]);
fi;
od;
return g;
end;

uy:=function(u)
local g,j;
g:=[];
for j in [1..Number(u)] do
if u[j] in [4,5,6] then
Add(g,u[j]-3);
fi;
od;
return g;
end;

uz:=function(u)
local g,j;
g:=[];
for j in [1..Number(u)] do
if u[j]>6 then
Add(g,u[j]-6);
fi;
od;
return g;
end;


#Now we can compute the full table of values for the cocycle.

table:=function(i,j)
local n,d,g;  
g:=[[[]],[0]];  
d:=dcopro(i,j);
for n in [1..Number(d[2])] do
g:=AddNP(g,MulNP(MulNP(gammam(ux(d[1][n])),gammam(uy(d[1][n]))),igammam(uz(d[1][n]))),1,d[2][n]);
od;
return
StrongNormalFormNP(g,G1d);
end;

Print("These are the non-zero values in the table of the cocycle associated to the deformation above. \n ");
for i in [1..11] do
for j in [1..11] do
if table(i,j)<>[[],[]] then
Print("The entry ");
Print("(");
Print(i);
Print(",");
Print(j);
Print(") is \n");
PrintNP(table(i,j));
fi;                
od;
od;

#For each monomial in the basis B, we record its position 1st to 12th
pos:=function(u)
for i in [1..12] do
 if u=B[i][1][1] then return 
 i;
 fi;
od;
end;


#We use the values in the table to define sigma in a monomial.
sigmam:=function(u,v)
if pos(u)=1 and pos(uy(v))=1 then return
[ [ [  ] ], [ F1 ] ];
else if pos(u)=1 and pos(uy(v))>1 then return
[ [ [  ] ], [ 0 ] ];
else if pos(u)>1 and pos(uy(v))=1 then return
[ [ [  ] ], [ 0 ] ];
else return
table(pos(u)-1,pos(uy(v))-1);
fi;
fi;
fi;
end;;


#We define alpha in monomials.
alphad:=function(u)
if u=B[1][1][1] then return
[ [ [  ] ], [ F1 ] ];
else if u=B[12][1][1] then return
[ [ [  ] ], [ -d ] ];
else return
[ [ [  ] ], [ 0 ] ];
fi;
fi;
end;;

#This defines the semi-orbit of sigma via alpha
presigmad:=function(i,j)
local n,f,g;  
g:=[[[]],[0]];  
f:=dcopro(i,j);
for n in [1..Number(f[2])] do
g:=AddNP(g,MulNP(sigmam(ux(f[1][n]),uy(f[1][n])+3),alphad(uz(f[1][n]))),1,f[2][n]);
od;
return
StrongNormalFormNP(g,G1d);
end;

#Finally, we subtract a factor d^2 in the last position, to obtain the orbit, out of the semi-orbit.

sigmad:=function(i,j)
local g;
if i=11 and j=11 then 
g:=AddNP(presigmad(i,j),u,1,-d^2);
else 
g:=presigmad(i,j);
fi;
return
StrongNormalFormNP(g,G1d);
end;

Print("As for the orbit under alpha_d, these are the non-zero values in the table of the orbit of the cocycle. \n ");
for p in [1..11] do
for q in [1..11] do
if sigmad(p,q)<>[[],[]] then
Print("For the entry ");
Print("(");
Print(p);
Print(",");
Print(q);
Print(") the value of the  d-cocycle is \n");
PrintNP(sigmad(p,q));
fi;                
od;
od;


