LogTo("cocycles/eta2-pointed.log");

#We refer to cocycle-pointed.g for details in the code.

LoadPackage("GBNP");

GBNP.ConfigPrint("x0","x1","x2","y0","y1","y2","z0","z1","z2","w0","w1","w2");

#we write h0, h3 for the values eta0, eta3
h0:=Indeterminate(Rationals,"h0");;
h3:=Indeterminate(Rationals,"h3");;

F:=Field(h0,h3);;
F1:=One(F);;

u:=[ [ [  ] ], [ F1 ] ];;
z:=[[[]],[0]];;


x0:=[[[1]],[1]];;
x1:=[[[2]],[1]];;
x2:=[[[3]],[1]];;

y0:=[[[4]],[1]];;
y1:=[[[5]],[1]];;
y2:=[[[6]],[1]];;

z0:=[[[7]],[1]];;
z1:=[[[8]],[1]];;
z2:=[[[9]],[1]];;

w0:=[[[10]],[1]];;
w1:=[[[11]],[1]];;
w2:=[[[12]],[1]];;

rx0:=MulNP(x0,x0);;
rx1:=MulNP(x1,x1);;
rx2:=MulNP(x2,x2);;
ry0:=MulNP(y0,y0);;
ry1:=MulNP(y1,y1);;
ry2:=MulNP(y2,y2);;
rz0:=MulNP(z0,z0);;
rz1:=MulNP(z1,z1);;
rz2:=MulNP(z2,z2);;
rw0:=MulNP(w0,w0);;
rw1:=MulNP(w1,w1);;
rw2:=MulNP(w2,w2);;

sx01:=AddNP(MulNP(x0,x1),AddNP(MulNP(x1,x2),MulNP(x2,x0),1,1),1,1);;
sx10:=AddNP(MulNP(x1,x0),AddNP(MulNP(x2,x1),MulNP(x0,x2),1,1),1,1);;
sy01:=AddNP(MulNP(y0,y1),AddNP(MulNP(y1,y2),MulNP(y2,y0),1,1),1,1);;
sy10:=AddNP(MulNP(y1,y0),AddNP(MulNP(y2,y1),MulNP(y0,y2),1,1),1,1);;
sz01:=AddNP(MulNP(z0,z1),AddNP(MulNP(z1,z2),MulNP(z2,z0),1,1),1,1);;
sz10:=AddNP(MulNP(z1,z0),AddNP(MulNP(z2,z1),MulNP(z0,z2),1,1),1,1);;
sw01:=AddNP(MulNP(w0,w1),AddNP(MulNP(w1,w2),MulNP(w2,w0),1,1),1,1);;
sw10:=AddNP(MulNP(w1,w0),AddNP(MulNP(w2,w1),MulNP(w0,w2),1,1),1,1);;

xy00:=AddNP(MulNP(y0,x0),MulNP(x0,y0),1,1);;
xy01:=AddNP(MulNP(y1,x0),MulNP(x2,y1),1,1);;
xy02:=AddNP(MulNP(y2,x0),MulNP(x1,y2),1,1);;
xy10:=AddNP(MulNP(y0,x1),MulNP(x2,y0),1,1);;
xy11:=AddNP(MulNP(y1,x1),MulNP(x1,y1),1,1);;
xy12:=AddNP(MulNP(y2,x1),MulNP(x0,y2),1,1);;
xy20:=AddNP(MulNP(y0,x2),MulNP(x1,y0),1,1);;
xy21:=AddNP(MulNP(y1,x2),MulNP(x0,y1),1,1);;
xy22:=AddNP(MulNP(y2,x2),MulNP(x2,y2),1,1);;

xz00:=AddNP(MulNP(z0,x0),MulNP(x0,z0),1,1);;
xz01:=AddNP(MulNP(z1,x0),MulNP(x2,z1),1,1);;
xz02:=AddNP(MulNP(z2,x0),MulNP(x1,z2),1,1);;
xz10:=AddNP(MulNP(z0,x1),MulNP(x2,z0),1,1);;
xz11:=AddNP(MulNP(z1,x1),MulNP(x1,z1),1,1);;
xz12:=AddNP(MulNP(z2,x1),MulNP(x0,z2),1,1);;
xz20:=AddNP(MulNP(z0,x2),MulNP(x1,z0),1,1);;
xz21:=AddNP(MulNP(z1,x2),MulNP(x0,z1),1,1);;
xz22:=AddNP(MulNP(z2,x2),MulNP(x2,z2),1,1);;

xw00:=AddNP(MulNP(w0,x0),MulNP(x0,w0),1,1);;
xw01:=AddNP(MulNP(w1,x0),MulNP(x2,w1),1,1);;
xw02:=AddNP(MulNP(w2,x0),MulNP(x1,w2),1,1);;
xw10:=AddNP(MulNP(w0,x1),MulNP(x2,w0),1,1);;
xw11:=AddNP(MulNP(w1,x1),MulNP(x1,w1),1,1);;
xw12:=AddNP(MulNP(w2,x1),MulNP(x0,w2),1,1);;
xw20:=AddNP(MulNP(w0,x2),MulNP(x1,w0),1,1);;
xw21:=AddNP(MulNP(w1,x2),MulNP(x0,w1),1,1);;
xw22:=AddNP(MulNP(w2,x2),MulNP(x2,w2),1,1);;

yz00:=AddNP(MulNP(z0,y0),MulNP(y0,z0),1,1);;
yz01:=AddNP(MulNP(z1,y0),MulNP(y2,z1),1,1);;
yz02:=AddNP(MulNP(z2,y0),MulNP(y1,z2),1,1);;
yz10:=AddNP(MulNP(z0,y1),MulNP(y2,z0),1,1);;
yz11:=AddNP(MulNP(z1,y1),MulNP(y1,z1),1,1);;
yz12:=AddNP(MulNP(z2,y1),MulNP(y0,z2),1,1);;
yz20:=AddNP(MulNP(z0,y2),MulNP(y1,z0),1,1);;
yz21:=AddNP(MulNP(z1,y2),MulNP(y0,z1),1,1);;
yz22:=AddNP(MulNP(z2,y2),MulNP(y2,z2),1,1);;

yw00:=AddNP(MulNP(w0,y0),MulNP(y0,w0),1,1);;
yw01:=AddNP(MulNP(w1,y0),MulNP(y2,w1),1,1);;
yw02:=AddNP(MulNP(w2,y0),MulNP(y1,w2),1,1);;
yw10:=AddNP(MulNP(w0,y1),MulNP(y2,w0),1,1);;
yw11:=AddNP(MulNP(w1,y1),MulNP(y1,w1),1,1);;
yw12:=AddNP(MulNP(w2,y1),MulNP(y0,w2),1,1);;
yw20:=AddNP(MulNP(w0,y2),MulNP(y1,w0),1,1);;
yw21:=AddNP(MulNP(w1,y2),MulNP(y0,w1),1,1);;
yw22:=AddNP(MulNP(w2,y2),MulNP(y2,w2),1,1);;


zw00:=AddNP(MulNP(w0,z0),MulNP(z0,w0),1,1);;
zw01:=AddNP(MulNP(w1,z0),MulNP(z2,w1),1,1);;
zw02:=AddNP(MulNP(w2,z0),MulNP(z1,w2),1,1);;
zw10:=AddNP(MulNP(w0,z1),MulNP(z2,w0),1,1);;
zw11:=AddNP(MulNP(w1,z1),MulNP(z1,w1),1,1);;
zw12:=AddNP(MulNP(w2,z1),MulNP(z0,w2),1,1);;
zw20:=AddNP(MulNP(w0,z2),MulNP(z1,w0),1,1);;
zw21:=AddNP(MulNP(w1,z2),MulNP(z0,w1),1,1);;
zw22:=AddNP(MulNP(w2,z2),MulNP(z2,w2),1,1);;

rels4:=[
rx0,rx1,rx2,ry0,ry1,ry2,rz0,rz1,rz2,rw0,rw1,rw2,
sx01,sx10,sy01,sy10,sz01,sz10,sw01,sw10,
xy00,xy01,xy02,xy10,xy11,xy12,xy20,xy21,xy22,
xz00,xz01,xz02,xz10,xz11,xz12,xz20,xz21,xz22,
xw00,xw01,xw02,xw10,xw11,xw12,xw20,xw21,xw22,
yz00,yz01,yz02,yz10,yz11,yz12,yz20,yz21,yz22,
yw00,yw01,yw02,yw10,yw11,yw12,yw20,yw21,yw22,
zw00,zw01,zw02,zw10,zw11,zw12,zw20,zw21,zw22
];;

G4:=SGrobner(rels4);;

d0:=StrongNormalFormNP(AddNP(x0,z0,1,1),G4);;
d1:=StrongNormalFormNP(AddNP(x1,z1,1,1),G4);;
d2:=StrongNormalFormNP(AddNP(x2,z2,1,1),G4);;

e0:=StrongNormalFormNP(AddNP(y0,w0,1,1),G4);;
e1:=StrongNormalFormNP(AddNP(y1,w1,1,1),G4);;
e2:=StrongNormalFormNP(AddNP(y2,w2,1,1),G4);;

d01:=StrongNormalFormNP(MulNP(d0,d1),G4);;
d02:=StrongNormalFormNP(MulNP(d0,d2),G4);;
d10:=StrongNormalFormNP(MulNP(d1,d0),G4);;
d12:=StrongNormalFormNP(MulNP(d1,d2),G4);;

e01:=StrongNormalFormNP(MulNP(e0,e1),G4);;
e02:=StrongNormalFormNP(MulNP(e0,e2),G4);;
e10:=StrongNormalFormNP(MulNP(e1,e0),G4);;
e12:=StrongNormalFormNP(MulNP(e1,e2),G4);;

d010:=StrongNormalFormNP(MulNP(d01,d0),G4);;
d012:=StrongNormalFormNP(MulNP(d01,d2),G4);;
d102:=StrongNormalFormNP(MulNP(d10,d2),G4);;

e010:=StrongNormalFormNP(MulNP(e01,e0),G4);;
e012:=StrongNormalFormNP(MulNP(e01,e2),G4);;
e102:=StrongNormalFormNP(MulNP(e10,e2),G4);;

d0102:=StrongNormalFormNP(MulNP(d010,d2),G4);;

e0102:=StrongNormalFormNP(MulNP(e010,e2),G4);;

v:=[d0,d1,d2,d01,d02,d10,d12,d010,d012,d102,d0102];;
w:=[e0,e1,e2,e01,e02,e10,e12,e010,e012,e102,e0102];;

B1:=BaseQA(G4,3,0);;

B2:=[u];;
for n in [2..12] do
Add(B2,[B1[n][1]+3,[1]]);
od;;

#These are the subsets of the basis where the Hochschild cocycles are nonzero.

X1:=[];
for i in [2..4] do
for j in [2..4] do
Add(X1,MulNP(B1[i],B2[j])[1][1]);
od;
od;;

Xp:=[
MulNP(B1[4],B2[9])[1][1],
MulNP(B1[6],B2[8])[1][1],
MulNP(B1[8],B2[6])[1][1],
MulNP(B1[11],B2[2])[1][1],
MulNP(B1[10],B2[3])[1][1]
];;

Xm:=[
MulNP(B1[2],B2[11])[1][1],
MulNP(B1[3],B2[10])[1][1],
MulNP(B1[5],B2[6])[1][1],
MulNP(B1[7],B2[8])[1][1],
MulNP(B1[6],B2[5])[1][1],
MulNP(B1[8],B2[7])[1][1],
MulNP(B1[9],B2[4])[1][1]
];;

#eta in monomials

etam:=function(u)
if u in X1 then return
[ [ [  ] ], [ h0 ] ];
else if u in Xp then return
[ [ [  ] ], [ h3 ] ];
else if u in Xm then return
[ [ [  ] ], [ -h3 ] ];
else return
z;
fi;fi;fi;
end;;

v:=[d0,d1,d2,d01,d02,d10,d12,d010,d012,d102,d0102];;
w:=[e0,e1,e2,e01,e02,e10,e12,e010,e012,e102,e0102];;


#double coproduct
dcopro:=function(i,j)
return
StrongNormalFormNP(MulNP(v[i],w[j]),G4);
end;;

# extractions

u1:=function(u)
local g,j;
g:=[];
for j in [1..Number(u)] do
if u[j]<7 then
Add(g,u[j]);
fi;
od;
return g;
end;;

u2:=function(u)
local g,j;
g:=[];
for j in [1..Number(u)] do
if u[j] in [7..12] then
Add(g,u[j]-6);
fi;
od;
return g;
end;;

eta2:=function(i,j)
local n,d,g;  
g:=[[[]],[0]];  
d:=dcopro(i,j);
for n in [1..Number(d[2])] do
g:=AddNP(g,MulNP(etam(u1(d[1][n])),etam(u2(d[1][n]))),1,d[2][n]);
od;
return
StrongNormalFormNP(g,G4);
end;;

Print("These are the non-zero values in the table for eta^2. \n ");
for i in [1..11] do
for j in [1..11] do
if eta2(i,j)<>[[],[]] then
Print("For the coordinate ");
Print("(");
Print(i);
Print(",");
Print(j);
Print(") eta^2 is \n");
PrintNP(eta2(i,j));
fi;
od;
od;;

